<?php

/*=======================*\
| CYBER-CITY | Metropolis |
+-------------------------+
| http://cyber-city.ru    |
\*=======================*/

/*-----------------------------------------*\
|   (FSY22) Members Online Today v3.2       |
+-------------------------------------------+
|   Library Functions File                  |
+-------------------------------------------+
|   (c) 2006 Michael McCune                 |
|   Email: michael.mccune@gmail.com         |
|   http://www.invisionmodding.com/forums   |
\*-----------------------------------------*/

if ( !defined( 'IN_IPB' ) )
{
	print "<h1> </h1>       .     ,      .";
	exit();
}

class func_mot
{
	var $ipsclass;
	var $sep_char = '<{ACTIVE_LIST_SEP}>';

	function most_online()
	{
		//-----------------------------------------
		// Initialize our main output array
		//-----------------------------------------

		$mems          = array();
		$mems['link']  = "";
		$mems['style'] = "style='display: inline-compact;'";

		//-----------------------------------------
		// Let's try not to hose the stats
		//-----------------------------------------

		$stats =& $this->ipsclass->cache['stats'];

		//-----------------------------------------
		// Integration with Group Name Indicator
		//-----------------------------------------

		if ( $this->ipsclass->vars['group_display_active'] && $this->ipsclass->vars['mot_w_gni'] && $this->ipsclass->DB->field_exists( 'g_display', 'groups' ) )
		{
			$order = 'g.g_display ASC, ';
		}

		//-----------------------------------------
		// Excluding any groups?
		//-----------------------------------------

		if ( $this->ipsclass->vars['g_exclude_mot'] != '' )
		{
			$exclude = ' AND m.mgroup NOT IN ('.$this->ipsclass->vars['g_exclude_mot'].')';
		}

		//-----------------------------------------
		// Query for the members
		//-----------------------------------------

		$this->ipsclass->DB->build_query ( array(	'select'   => 'm.id, m.members_display_name, m.mgroup, m.last_activity',
													'from'     => array( 'members' => 'm' ),
													'where'    => "m.id <> 0 AND m.last_activity > ".time()." - 172800{$exclude}",
													'add_join' => array( 0 => array( 'from'   => array( 'groups' => 'g' ),
    																				 'where'  => 'm.mgroup=g.g_id',
    																				 'type'   => 'left' ) ),
													'order'    => "{$order}m.members_display_name ASC",
										 )      );
		$this->ipsclass->DB->exec_query();

		//-----------------------------------------
		// Sort out the expand/collapse
		//-----------------------------------------

		if ( $this->ipsclass->vars['expcol_mot'] )
		{
			if ( $this->ipsclass->my_getcookie( "hidemot" ) )
			{
				$mems['style'] = "style='display: none;'";
				$mems['link']  = "<span id='mot_explink' style='display: inline;'>[<a href='javascript:expand_mot()'>{$this->ipsclass->lang['mot_expand']}</a>]</span><span id='mot_collink' style='display: none;'>[<a href='javascript:collapse_mot()'>{$this->ipsclass->lang['mot_collapse']}</a>]</span>";
			}
			else
			{
				$mems['link']  = "<span id='mot_explink' style='display: none;'>[<a href='javascript:expand_mot()'>{$this->ipsclass->lang['mot_expand']}</a>]</span><span id='mot_collink' style='display: inline;'>[<a href='javascript:collapse_mot()'>{$this->ipsclass->lang['mot_collapse']}</a>]</span>";
			}
		}

		//-----------------------------------------
		// Has anyone been online in a while?
		//-----------------------------------------

		if ( !$this->ipsclass->DB->get_num_rows() )
		{
			$mems['list'] = "<br /><br />".$this->ipsclass->lang['online_today_none'];
		}
		else
		{
			$mems['list'] = "<br /><br />".$this->ipsclass->lang['online_today_list']."<br />";

			while ( $user = $this->ipsclass->DB->fetch_row() )
			{
				//-----------------------------------------
				// Check if they've been online today
				//-----------------------------------------

				if ( $user['last_activity'] > 0 )
				{
					if ( $this->ipsclass->get_time( $user['last_activity'], 'j-n-Y' ) == $this->ipsclass->get_time( time(), 'j-n-Y' ) )
					{
						$the_date = $this->ipsclass->lang['last_active'].": ".$this->ipsclass->get_date( $user['last_activity'], 'LONG' );
						$mems['list'] .= "<a title=\"{$the_date}\" href=\"{$this->ipsclass->base_url}showuser={$user['id']}\">".$this->ipsclass->make_name_formatted( $user['members_display_name'], $user['mgroup'] )."</a>{$this->sep_char} \n";
						$mems['count']++;
					}
				}
			}

			$mems['list']  = preg_replace( "/".preg_quote( $this->sep_char )."$/", "", trim( $mems['list'] ) );
		}

		//-----------------------------------------
		// Did we break our record?
		//-----------------------------------------

		if ( $mems['count'] >= $stats['most_mem_day'] )
		{
			$stats['most_mem_day']  = $mems['count'];
			$stats['most_mem_date'] = time();

			$this->ipsclass->update_cache( array( 'name' => 'stats', 'array' => 1, 'deletefirst' => 1 ) );
		}

		//-----------------------------------------
		// What day had the most members online?
		//-----------------------------------------

		$this->ipsclass->time_options['DAY'] = "F jS, Y";
		$most_mem_date = $this->ipsclass->get_date( $stats['most_mem_date'], 'DAY', 1 );

		//-----------------------------------------
		// Build our language string
		//-----------------------------------------

		$this->ipsclass->lang['online_most_ever'] = str_replace( "<#COUNT#>", $stats['most_mem_day'], $this->ipsclass->lang['online_most_ever'] );
		$this->ipsclass->lang['online_most_ever'] = str_replace( "<#DATE#>" , "$most_mem_date"      , $this->ipsclass->lang['online_most_ever'] );

		//-----------------------------------------
		// Finally, output the skin template
		//-----------------------------------------

		return $this->ipsclass->compiled_templates['skin_boards']->most_online($mems);
	}
}

?>